#include <linux/sdt.h>
extern void ipath_release_mmap_info(void);
extern void ipath_modify_qp(void);
extern void ipath_create_mmap_info(void);
extern void ipath_multicast_detach(void);
extern void ipath_create_srq(void);
extern void ipath_modify_srq(void);
extern void ipath_update_mmap_info(void);
extern void ipath_destroy_qp(void);
extern void ipath_multicast_attach(void);
extern void ipath_create_qp(void);
extern void ipath_create_cq(void);
extern void __dta___raw_spin_unlock_irq_35(void);
extern void ipath_mmap(void);
extern void ipath_resize_cq(void);

static sdt_probedesc_t	_sdt_probes[] = {
  {"__lockstat_spin__release",  "__raw_spin_unlock_irq" /* .text */, 0 /* sdt_args string */, (uintptr_t)__dta___raw_spin_unlock_irq_35+0x0000000000000018 },
  {"__lockstat_spin__release",  "ipath_create_cq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_create_cq+0x000000000000012e },
  {"__lockstat_spin__release",  "ipath_resize_cq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_resize_cq+0x00000000000001d3 },
  {"__lockstat_spin__release",  "ipath_resize_cq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_resize_cq+0x000000000000023f },
  {"__lockstat_spin__release",  "ipath_release_mmap_info" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_release_mmap_info+0x0000000000000045 },
  {"__lockstat_spin__release",  "ipath_mmap" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_mmap+0x00000000000000c9 },
  {"__lockstat_spin__release",  "ipath_mmap" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_mmap+0x0000000000000111 },
  {"__lockstat_spin__release",  "ipath_create_mmap_info" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_create_mmap_info+0x0000000000000095 },
  {"__lockstat_spin__release",  "ipath_update_mmap_info" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_update_mmap_info+0x0000000000000072 },
  {"__lockstat_spin__release",  "ipath_modify_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_qp+0x00000000000001c8 },
  {"__lockstat_spin__release",  "ipath_modify_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_qp+0x0000000000000374 },
  {"__lockstat_spin__release",  "ipath_modify_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_qp+0x00000000000005b5 },
  {"__lockstat_spin__release",  "ipath_create_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_create_qp+0x00000000000006e0 },
  {"__lockstat_spin__release",  "ipath_destroy_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_destroy_qp+0x00000000000000c8 },
  {"__lockstat_spin__release",  "ipath_destroy_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_destroy_qp+0x0000000000000150 },
  {"__lockstat_spin__release",  "ipath_destroy_qp" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_destroy_qp+0x00000000000001d4 },
  {"__lockstat_spin__release",  "ipath_create_srq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_create_srq+0x000000000000017b },
  {"__lockstat_spin__release",  "ipath_modify_srq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_srq+0x00000000000001f3 },
  {"__lockstat_spin__release",  "ipath_modify_srq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_srq+0x000000000000024a },
  {"__lockstat_spin__release",  "ipath_modify_srq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_srq+0x00000000000002bc },
  {"__lockstat_spin__release",  "ipath_modify_srq" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_modify_srq+0x000000000000038e },
  {"__lockstat_spin__release",  "ipath_multicast_attach" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_multicast_attach+0x0000000000000244 },
  {"__lockstat_spin__release",  "ipath_multicast_detach" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_multicast_detach+0x0000000000000097 },
  {"__lockstat_spin__release",  "ipath_multicast_detach" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_multicast_detach+0x000000000000017d },
  {"__lockstat_spin__release",  "ipath_multicast_detach" /* .text */, 0 /* sdt_args string */, (uintptr_t)ipath_multicast_detach+0x000000000000028e },
};

#define _sdt_probec	25
